%define name		spring
%define version		1.1.4
%define release		2jpp
%define	section		free


Name:		%{name}
Summary:	Spring J2EE Framework
Url:		http://www.springframework.org/
Version:	%{version}
Release:	%{release}
Epoch:		0
License:	Apache Software License 2.0
Group:		Development/Libraries/Application Frameworks
Vendor:		JPackage Project
Distribution:	JPackage
BuildArch:	noarch
Source0:	spring-framework-1.1.4.zip
Patch0:		spring-1.1.4-PathMatchingResourcePatternResolverTests.patch
Patch1:		spring-1.1.4-SqlClientMapTests.patch
Patch2:		spring-1.1.4-JaxRpcSupportTests.patch

BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:	ant >= 0:1.6
BuildRequires:	junit 
BuildRequires:	java >= 0:1.4
# activemq
#BuildRequires:  activemq
# asm
BuildRequires:	asm
# axis
BuildRequires:	axis
# bsh
BuildRequires:	bsh
# burlap
BuildRequires:	burlap
# cglib
BuildRequires:	cglib
# commons-attributes
BuildRequires:	jakarta-commons-attributes
# commons-collections
BuildRequires:	jakarta-commons-collections
# commons-dbcp
BuildRequires:	jakarta-commons-dbcp
# commons-fileupload
BuildRequires:	jakarta-commons-fileupload
# commons-httpclient
BuildRequires:	jakarta-commons-httpclient
# commons-lang
BuildRequires:	jakarta-commons-lang
# commons-logging
BuildRequires:	jakarta-commons-logging
# commons-pool
BuildRequires:	jakarta-commons-pool
# jakarta-taglibs-standard
BuildRequires:	jakarta-taglibs-standard
# concurrent
BuildRequires:	concurrent
# cos
BuildRequires:	cos-multipart
# db-ojb
BuildRequires:	db-ojb
# dom4j
BuildRequires:	dom4j
# easymock
BuildRequires:	easymock
# ehcache
BuildRequires:  ehcache
# ejb
BuildRequires:	ejb
# freemarker
BuildRequires:	freemarker
# hessian
BuildRequires:	hessian
# hibernate
BuildRequires:	hibernate
# ibatis
BuildRequires:	ibatis
# ibatis1
BuildRequires:	ibatis1
# itext
BuildRequires:	itext
# j2ee-management
BuildRequires:	j2ee-management
# jaf
BuildRequires:	jaf
# jamonapi
BuildRequires:	jamonapi
# jasperreports
BuildRequires:	jasperreports >= 0:0.6.4
# javamail
BuildRequires:	javamail
# jaxen
BuildRequires:	jaxen
# jdo
BuildRequires:	jdo
# jdom
BuildRequires:	jdom
# jms
BuildRequires:	jms
# jotm
BuildRequires:	jotm
# jsf
BuildRequires:	jsf
# jta
BuildRequires:	jta
## poi 
BuildRequires:	jakarta-poi
# log4j
BuildRequires:	log4j
# oro
BuildRequires:	oro
# quartz
BuildRequires:	quartz
# servletapi4
BuildRequires:	servletapi4
# struts
BuildRequires:	struts
# velocity
BuildRequires:	velocity
# velocity-tools
BuildRequires:	velocity-tools
# xapool
BuildRequires:	xapool
# xjavadoc
BuildRequires:	xjavadoc

Requires:	java >= 0:1.4

BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Spring is a layered Java/J2EE application framework, 
based on code published in Expert One-on-One J2EE 
Design and Development by Rod Johnson (Wrox, 2002). 

%package core
Summary:	%{name} core
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	jakarta-commons-logging

%description core
%{name} bean container, core utilities
Optionals: log4j

%package aop
Summary:	%{name} aop
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}
Requires:	aopalliance

%description aop
%{name} AOP framework, source level metadata support
Optionals: cglib, jakarta-commons-attributes

%package context
Summary:	%{name} context
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}

%description context
%{name} application context, validation, UI support, mail,
JNDI, JMS, EJB, remoting, scheduling, caching
Optionals: velocity, freemarker, javamail, jms, ejb, axis,
hessian, burlap, quartz, ehcache

%package dao
Summary:	%{name} dao
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}

%description dao
%{name} DAO support, transaction infrastructure, JDBC support
Optionals: spring-aop, jta

%package orm
Summary:	%{name} orm
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-dao = 0:%{version}-%{release}

%description orm
%{name} Hibernate support, JDO support, Apache OJB, iBATIS SQL Maps
Optionals: hibernate, jdo, db-ojb, ibatis

%package web
Summary:	%{name} web
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-context = 0:%{version}-%{release}
Requires:	servlet

%description web
%{name} web application support, multipart resolver, struts support,
web utilities
Optionals: jspapi, jakarta-taglibs-standard, jakarta-commons-fileupload,
cos-multipart, struts

%package webmvc
Summary:	%{name} webmvc
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-web = 0:%{version}-%{release}

%description webmvc
%{name} framework servlets, web MVC framework, web controllers, web views
Optionals: tiles, itext, poi

%package all
Summary:	%{name} all except mocks
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	jakarta-commons-logging
Requires:	aopalliance
Requires:	servlet

%description all
%{name} everything except mocks
Optionals: log4j, cglib, jakarta-commons-attributes
velocity, freemarker, javamail, jms, ejb, axis, hessian, 
burlap, quartz, ehcache, jta, hibernate, jdo, ojb, ibatis,
jspapi, jakarta-taglibs-standard, jakarta-commons-fileupload,
tiles, itest, poi

%package mock
Summary:	%{name} mock
Group:		Development/Libraries/Application Frameworks
Requires:	%{name} = 0:%{version}-%{release}
Requires:	%{name}-core = 0:%{version}-%{release}

%description mock
%{name} JNDI mocks, Servlet API mocks

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:	Documents for %{name}
Group:		Development/Documentation

%description manual
%{summary}.

%package demo
Summary:	Samples for %{name}
Group:		Development/Documentation

%description demo
%{summary}.

%prep
%setup -q -n %{name}-framework-%{version}
chmod -R go=u-w *
#find . -name "*.jar" -exec rm {} \;
for f in $(find . -name "*.jar"); do
    mv $f $f.no
done

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav

%build

mkdir lib
pushd lib
mkdir aopalliance
pushd aopalliance
ln -sf $(build-classpath aopalliance) .
popd
mkdir axis
pushd axis
ln -sf $(build-classpath axis/axis) .
ln -sf $(build-classpath axis/saaj) .
ln -sf $(build-classpath wsdl4j) .
popd
mkdir bsh
pushd bsh
ln -sf $(build-classpath bsh) .
popd
mkdir caucho
pushd caucho
ln -sf $(build-classpath burlap) burlap-2.1.12.jar
ln -sf $(build-classpath hessian) hessian-2.1.12.jar
popd
mkdir cglib
pushd cglib
ln -sf $(build-classpath cglib) cglib-full-2.0.2.jar
ln -sf $(build-classpath asm/asm) .
popd
mkdir concurrent
pushd concurrent
ln -sf $(build-classpath concurrent) concurrent-1.3.4.jar
popd
mkdir cos
pushd cos
ln -sf $(build-classpath cos-multipart) cos.jar
popd
mkdir dom4j
pushd dom4j
ln -sf $(build-classpath dom4j) .
ln -sf $(build-classpath jaxen) .
popd
mkdir easymock
pushd easymock
ln -sf $(build-classpath easymock) .
popd
mkdir ehcache
pushd ehcache
ln -sf $(build-classpath ehcache) ehcache-1.0.jar
popd
mkdir freemarker
pushd freemarker
ln -sf $(build-classpath freemarker) .
popd
mkdir hibernate
pushd hibernate
ln -sf $(build-classpath hibernate) hibernate2.jar
#ln -sf $(build-classpath odmg) .
popd
mkdir hsqldb
pushd hsqldb
ln -sf $(build-classpath hsqldb) .
popd
mkdir ibatis
pushd ibatis
ln -sf $(build-classpath ibatis1-common) ibatis-common.jar
ln -sf $(build-classpath ibatis1-sqlmap) ibatis-sqlmap.jar
ln -sf $(build-classpath ibatis-sqlmap) ibatis-sqlmap-2.jar
popd
mkdir itext
pushd itext
ln -sf $(build-classpath itext) itext-1.02b.jar
#ln -sf $(build-classpath pdfbox) pdfbox-0.6.5.jar
popd
mkdir j2ee
pushd j2ee
ln -sf $(build-classpath axis/jaxrpc) .
ln -sf $(build-classpath ejb) .
#ln -sf $(build-classpath j2ee-connector) connector-api.jar
ln -sf $(build-classpath jms) .
ln -sf $(build-classpath jta) .
ln -sf $(build-classpath javamail/mailapi) mail.jar
ln -sf $(build-classpath jaf) activation.jar
ln -sf $(build-classpath taglibs-core) jstl-core.jar
ln -sf $(build-classpath taglibs-standard) jstl.jar
ln -sf $(build-classpath servletapi4) servlet.jar
popd
mkdir endorsed
pushd endorsed
ln -sf $(build-classpath xerces-j2) xerces.jar
ln -sf $(build-classpath xml-commons-apis) xml-apis.jar
popd
mkdir jakarta-commons
pushd jakarta-commons
ln -sf $(build-classpath commons-attributes-api) .
ln -sf $(build-classpath commons-attributes-compiler) .
#ln -sf $(build-classpath commons-beanutils) .
ln -sf $(build-classpath commons-collections) .
ln -sf $(build-classpath commons-dbcp) .
#ln -sf $(build-classpath commons-digester) .
#ln -sf $(build-classpath commons-discovery) .
ln -sf $(build-classpath commons-fileupload) .
ln -sf $(build-classpath commons-httpclient) .
ln -sf $(build-classpath commons-lang) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath commons-pool) .
#ln -sf $(build-classpath commons-validator) .
popd
mkdir jamon
pushd jamon
ln -sf $(build-classpath jamonapi) JAMon.jar
popd
mkdir jasperreports
pushd jasperreports
ln -sf $(build-classpath jasperreports) jasperreports-0.6.4.jar
popd
mkdir jdo
pushd jdo
ln -sf $(build-classpath jdo/jdo) .
ln -sf $(build-classpath jdo/jdori) jdori-1.0.1.jar
popd
mkdir jdom
pushd jdom
ln -sf $(build-classpath jdom) .
popd
mkdir jotm
pushd jotm
ln -sf $(build-classpath jotm/jotm) .
ln -sf $(build-classpath xapool) .
popd
mkdir jsf
pushd jsf
ln -sf $(build-classpath jsf-api) .
popd
#mkdir junit
#pushd junit
#ln -sf $(build-classpath junit) .
#popd
mkdir log4j
pushd log4j
ln -sf $(build-classpath log4j) log4j-1.2.8.jar
popd
mkdir ojb
pushd ojb
ln -sf $(build-classpath db-ojb/db-ojb) db-ojb-1.0.0.jar
popd
mkdir oro
pushd oro
ln -sf $(build-classpath oro) jakarta-oro-2.0.8.jar
popd
mkdir poi
pushd poi
ln -sf $(build-classpath poi) poi-2.5.1.jar
popd
mkdir quartz
pushd quartz
ln -sf $(build-classpath quartz) .
popd
mkdir struts
pushd struts
ln -sf $(build-classpath struts) struts-1.1.jar
popd
mkdir velocity
pushd velocity
ln -sf $(build-classpath velocity-tools-generic) velocity-tools-generic-1.1.jar
ln -sf $(build-classpath velocity-tools-view) velocity-tools-view-1.1.jar
ln -sf $(build-classpath velocity) velocity-1.4.jar
popd
mkdir xdoclet
pushd xdoclet
ln -sf $(build-classpath xjavadoc) xjavadoc-1.0.jar
popd
popd

export OPT_JAR_LIST="ant/ant-junit junit xjavadoc commons-collections commons-attribute-compiler"

ant -Djava.endorsed.dir=lib/endorsed alljars tests

%install

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 dist/%{name}-aop.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/aop-%{version}.jar
install -m 644 dist/%{name}-context.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/context-%{version}.jar
install -m 644 dist/%{name}-core.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 dist/%{name}-dao.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/dao-%{version}.jar
install -m 644 dist/%{name}-mock.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/mock-%{version}.jar
install -m 644 dist/%{name}-orm.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/orm-%{version}.jar
install -m 644 dist/%{name}-web.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/web-%{version}.jar
install -m 644 dist/%{name}-webmvc.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}/webmvc-%{version}.jar
install -m 644 dist/%{name}.jar \
	$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# definitions
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
install -m 644 dist/%{name}-beans.dtd \
	$RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/%{name}-beans.dtd
install -m 644 dist/%{name}.ftl \
	$RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/%{name}.ftl
install -m 644 dist/%{name}.tld \
	$RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/%{name}.tld
install -m 644 dist/%{name}.vm \
	$RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/%{name}.vm

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf docs/api

# manual
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr docs/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -p license.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}

# demo
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/samples
cp -pr samples/* $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/samples

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%dir %{_datadir}/%{name}-%{version}
%dir %{_datadir}/%{name}-%{version}/etc
%{_datadir}/%{name}-%{version}/etc/*
%{_docdir}/%{name}-%{version}/license.txt

%files core
%defattr(-,root,root)
%{_javadir}/%{name}/core*.jar

%files aop
%defattr(-,root,root)
%{_javadir}/%{name}/aop*.jar

%files context
%defattr(-,root,root)
%{_javadir}/%{name}/context*.jar

%files dao
%defattr(-,root,root)
%{_javadir}/%{name}/dao*.jar

%files orm
%defattr(-,root,root)
%{_javadir}/%{name}/orm*.jar

%files web
%defattr(-,root,root)
%{_javadir}/%{name}/web-*.jar
%{_javadir}/%{name}/web.jar

%files webmvc
%defattr(-,root,root)
%{_javadir}/%{name}/webmvc*.jar

%files all
%defattr(-,root,root)
%{_javadir}/%{name}*.jar

%files mock
%defattr(-,root,root)
%{_javadir}/%{name}/mock*.jar

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root)
%{_docdir}/%{name}-%{version}

%files demo
%defattr(-,root,root)
%{_datadir}/%{name}-%{version}/samples

%changelog
* Fri Mar 11 2005 Ralph Apel <r.apel at r-apel.de> 0:1.1.4-2jpp
- Adapt to axis-1.2: JaxRpcSupportTests.java to override loadService()

* Wed Feb 16 2005 Ralph Apel <r.apel at r-apel.de> 0:1.1.4-1jpp
- Upgrade to 1.1.4 (thx Joe Wortmann)

* Mon Dec 13 2004 Ralph Apel <r.apel at r-apel.de> 0:1.1.3-1jpp
- Upgrade to 1.1.3
- Break up into subpackages and relax dependencies
- Fix non-versioned jars in /usr/share/java/spring

* Fri Oct 08 2004 Ralph Apel <r.apel at r-apel.de> 0:1.1-1jpp
- First release

